/* IOEngine.h - TransparentIRC 0.1
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _IOEngine_h
#define _IOEngine_h
#include "overall.h"

struct IODescriptor;

extern struct IODescriptor *first_descriptor;

struct IOEngine {
    const char *name;
    int (*init)(void);
    void (*add)(struct IODescriptor *iofd);
    void (*remove)(struct IODescriptor *iofd);
    void (*update)(struct IODescriptor *iofd);
    void (*loop)(struct timeval *timeout);
    void (*cleanup)(void);
};

#define iohandler_wants_writes(IOFD) (IOFD->writebuf.bufpos || IOFD->state == IO_CONNECTING) 

void iohandler_events(struct IODescriptor *iofd, int readable, int writeable);

#endif
