/* main.c - TransparentIRC 0.1
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "IOHandler.h"
#include "ServerSocket.h"

char *configFile = "transirc.conf";

static void parseParameters(int argc, char *argv[]) {
    int c;
    struct option options[] = {
        {"config", 1, 0, 'c'},
        {0, 0, 0, 0}
    };
    while ((c = getopt_long(argc, argv, "s:fvh", options, NULL)) != -1) {
        switch (c) {
        case 'c':
            configFile = strdup(optarg);
            break;
        }
    }
}

int main(int argc, char *argv[]) {
    #ifndef WIN32
    if(geteuid() == 0 || getuid() == 0) {
        fprintf(stderr, "TransparentIRC may not be run with super user privileges.\n");
        exit(0);
    }
    #endif
    parseParameters(argc, argv);
    
    serversocket_listen("0.0.0.0", 9001);
    
    while(1) {
        iohandler_poll();
    }
}

